// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Preferences;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlPreferencesView")]
    pub struct PreferencesView(Object<ffi::DzlPreferencesView, ffi::DzlPreferencesViewClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable, Preferences;

    match fn {
        type_ => || ffi::dzl_preferences_view_get_type(),
    }
}

impl PreferencesView {
    pub const NONE: Option<&'static PreferencesView> = None;

    #[doc(alias = "dzl_preferences_view_new")]
    pub fn new() -> PreferencesView {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_preferences_view_new()).unsafe_cast() }
    }
}

impl Default for PreferencesView {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::PreferencesView>> Sealed for T {}
}

pub trait PreferencesViewExt: IsA<PreferencesView> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_preferences_view_get_show_search_entry")]
    #[doc(alias = "get_show_search_entry")]
    fn shows_search_entry(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_preferences_view_get_show_search_entry(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_preferences_view_get_use_sidebar")]
    #[doc(alias = "get_use_sidebar")]
    fn uses_sidebar(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_preferences_view_get_use_sidebar(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_preferences_view_reapply_filter")]
    fn reapply_filter(&self) {
        unsafe {
            ffi::dzl_preferences_view_reapply_filter(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_preferences_view_set_show_search_entry")]
    fn set_show_search_entry(&self, show_search_entry: bool) {
        unsafe {
            ffi::dzl_preferences_view_set_show_search_entry(
                self.as_ref().to_glib_none().0,
                show_search_entry.into_glib(),
            );
        }
    }

    #[doc(alias = "dzl_preferences_view_set_use_sidebar")]
    fn set_use_sidebar(&self, use_sidebar: bool) {
        unsafe {
            ffi::dzl_preferences_view_set_use_sidebar(
                self.as_ref().to_glib_none().0,
                use_sidebar.into_glib(),
            );
        }
    }

    #[doc(alias = "show-search-entry")]
    fn connect_show_search_entry_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_search_entry_trampoline<
            P: IsA<PreferencesView>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlPreferencesView,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(PreferencesView::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-search-entry\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_search_entry_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "use-sidebar")]
    fn connect_use_sidebar_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_use_sidebar_trampoline<
            P: IsA<PreferencesView>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlPreferencesView,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(PreferencesView::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::use-sidebar\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_use_sidebar_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<PreferencesView>> PreferencesViewExt for O {}

impl fmt::Display for PreferencesView {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("PreferencesView")
    }
}
